// PCAN Explorer Macro File
// This file can be edited and run within PCAN Explorer version 3 (Currently running version 3.2.2.374).

//This macro program sets the S600 drive to Profile Position Mode, commands target positions,
//and executes absolute moves with time delays between.
//Configure the S600 drive to run motion tasks in position mode. Save to eeprom and do a Coldstart. Then run this program.



//set hartbeat.  It is not being used in this program, but could be as follows.
//Send 601h  8  2bh 17h 10h 00h F4h 01h 00h 00h // Switch on heart beat
//WaitId 12 581h 
//Send 601h  8  40h 17h 10h 00h 00h 00h 00h 00h // read back
//Waitdata 12 581h 8 4Bh 17h 10h 00h F4h 01h 00h 00h
//If False
//    Call IsThereAFault


//Set up PDO's
//RPDO1 is automatically set to the Control Word every time the S600 drive boots up.  So there is no need to configure it.
//If you want to configure it differently, use the following.
//This program uses RPDO1 to command the Control Word, which enables and starts motion.

//RPDO1
//Send 601h  8  2Fh 00h 26h 00h 25h 00h 00h 00h // Select PDO 37 as RPDO1
//Wait 20
//Send 601h 8 40h 00h 26h 00h 00h 00h 00h 00h
//Wait 20

//Send 601h  8  23h 00h 16h 00h 00h 00h 00h 00h // delete RPDO1 mapping
//Wait 20
//Send 601h 8 40h 00h 16h 00h 00h 00h 00h 00h
//Wait 20

//Send 601h  8  23h 00h 16h 01h 10h 00h 40h 60h // RPDO entry 1 map: Control Word
//Wait 20
//Send 601h 8 40h 00h 16h 01h 00h 00h 00h 00h // RPDO2 entry 1
//Wait 20

//RPDO2
//Check to see if RPDO2 is already configured.  The program hangs if you try to configure it after it is already configured.
Send 601h 8 40h 01h 26h 00h 00h 00h 00h 00h  // read selection of PDO2
Waitdata 200 581h 8 4Fh 01h 26h 00h 26h 00h 00h 00h  // check for selection of PDO 38
//PDO 38 is the second user configurable PDO in the S600.
	If false
	call PDOselect

Send 601h 8 40h 01h 16h 00h 00h 00h 00h 00h  // read number of RPDO2 entries
Waitdata 200 581h 8 43h 01h 16h 00h 00h 00h 00h 00h  // check for zero entries
//Check to see if it is mapped or not.
	If false
	call RPDO2delete

Send 601h 8 40h 01h 16h 01h 00h 00h 00h 00h  // read RPDO2 map
//Check: Target Position (Obj.607A) mapped to RPDO2
Waitdata 200 581h 8 43h 01h 16h 01h 20h 00h 7Ah 60h  //check for RPDO2 map target position
	If false
	call RPDO2map


//TxPDO's can be set up as follows.  They are not needed for this program.

//TPDO1	
//Send 601h  8  23h 00h 1Ah 00h 00h 00h 00h 00h // delete TPDO1 mapping
//Wait 20
//Send 601h 8 40h 00h 1Ah 00h 00h 00h 00h 00h // TPDO1
//Wait 20

//Send 601h  8  23h 00h 1Ah 01h 10h 00h 41h 60h // TPDO1 entry 1: status word
//Wait 20
//Send 601h 8 40h 00h 1Ah 01h 00h 00h 00h 00h // TPDO1 entry 1
//Wait 20

//Send 601h  8  23h 00h 1Ah 02h 08h 09h 80h 20h // TPDO1 entry 2: TRJSTAT Byte 3
//Wait 20
//Send 601h 8 40h 00h 1Ah 02h 00h 00h 00h 00h // TPDO1 entry 2
//Wait 20

//TPDO2
//Send 601h  8  23h 01h 1Ah 00h 00h 00h 00h 00h // delete TPDO2 mapping
//Wait 20
//Send 601h 8 40h 01h 1Ah 00h 00h 00h 00h 00h // TPDO2
//Wait 20

//Send 601h  8  23h 01h 1Ah 01h 20h 00h 64h 60h // TPDO2 entry 1: position actual value
//Wait 20
//Send 601h 8 40h 01h 1Ah 01h 00h 00h 00h 00h // TPDO2 entry 1
//Wait 20

//Send 601h  8  23h 01h 1Ah 02h 20h 00h 6Ch 60h // TPDO2 entry 2: velocity actual value
//Wait 20
//Send 601h 8 40h 01h 1Ah 02h 00h 00h 00h 00h // TPDO2 entry 2
//Wait 20

//TPDO2 transmit type
//Send 601h  8  23h 01h 18h 02h 01h 00h 00h 00h // TPDO2 transmit on every sync
//Wait 20
//Send 601h 8 40h 01h 18h 02h 00h 00h 00h 00h // TPDO2
//Wait 20



//Set up PGEARI and PGEARO
Send 601h  8  23h 93h 60h 01h 00h 00h 10h 00h // PGEARO = 20 bit
Wait 20
Send 601h 8 40h 93h 60h 01h 00h 00h 00h 00h // 
Wait 20

Send 601h  8  23h 93h 60h 02h 10h 27h 00h 00h // PGEARI = 10000 units
Wait 20
Send 601h 8 40h 93h 60h 02h 00h 00h 00h 00h // 
Wait 20

// ready to switch on	
Send 601h  8  2bh 40h 60h 00h 06h 00h 00h 00h // Control Word: ready to switch on
Wait 20
Send 601h  8 40h 41h 60h 00h 00h 00h 00h 00h // status word
Wait 20

Send 601h  8  2bh 40h 60h 00h 07h 00h 00h 00h // Control Word: switched on
Wait 20
Send 601h  8 40h 41h 60h 00h 00h 00h 00h 00h // status word
Wait 20

Send 601h  8  2bh 40h 60h 00h 0Fh 00h 00h 00h // Control Word: operation enable
Wait 20
Send 601h  8 40h 41h 60h 00h 00h 00h 00h 00h // status word
Wait 20

//***** Home Mode *****
Send 601h  8  2fh 60h 60h 00h 06h 00h 00h 00h // switch to homing mode
Wait 20
Send 601h 8 40h 61h 60h 00h 00h 00h 00h 00h // status word
Wait 20

Send 601h  8  2fh 98h 60h 00h 23h 00h 00h 00h // homing mode: set reference position
Wait 20
Send 601h 8 40h 98h 60h 00h 00h 00h 00h 00h // status word
Wait 20

Send 601h  8  2bh 40h 60h 00h 1Fh 00h 00h 00h // Control Word: start homing
Wait 20
Send 601h  8 40h 41h 60h 00h 00h 00h 00h 00h // status word
Wait 20

Wait 100 //allow time to process homing

Send 601h  8  2bh 40h 60h 00h 0Fh 00h 00h 00h // Control Word: stop homing (after finished)
Wait 20

Send 601h  8  2bh 40h 60h 00h 06h 00h 00h 00h // Control Word: ready to switch on
Wait 20


//**** Setup move ****

Send 601h  8  2Fh 60h 60h 00h 01h 00h 00h 00h // switch to profile position mode
Wait 20
Send 601h 8 40h 61h 60h 00h 00h 00h 00h 00h
Wait 20

Send 601h  8  23h 83h 60h 00h 32h 00h 00h 00h // acceleration
Wait 20
Send 601h 8 40h 83h 60h 00h 00h 00h 00h 00h
Wait 20

Send 601h  8  23h 84h 60h 00h 32h 00h 00h 00h // deceleration
Wait 20
Send 601h 8 40h 84h 60h 00h 00h 00h 00h 00h
Wait 20

Send 601h  8  23h 81h 60h 00h 88h 53h 51h 00h // Profile Velocity setpoint
Wait 20
Send 601h 8 40h 81h 60h 00h 00h 00h 00h 00h
Wait 20

Send 601h  8  23h 94h 60h 01h 00h 00h 10h 00h // Velocity encoder factor - numerator
Wait 20
Send 601h 8 40h 94h 60h 01h 00h 00h 00h 00h
Wait 20

Send 601h  8  23h 94h 60h 02h 01h 00h 00h 00h // Velocity encoder factor - denominator
Wait 20
Send 601h 8 40h 94h 60h 02h 00h 00h 00h 00h
Wait 20

Send 601h  8  2bh 40h 60h 00h 0Fh 00h 00h 00h // Control Word: operation enabled, relative move
Wait 20
Send 601h  8 40h 41h 60h 00h 00h 00h 00h 00h // status word
Wait 20

Send 000h  2  01h 01h // NMT: start PDO's
Wait 100

//Send 301h  8  10h 27h 00h 00h E8h 03h 00h 00h // RPDO2 Profile Velocity setpoint

JumpToHere:
//Enter Target Position Setpoint
Send 301h  8  C4h 09h 00h 00h E8h 03h 00h 00h // RPDO2 target position - sets a new target position
Wait 50
Send 201h  2  1Fh 00h // RPDO1 Control Word bit 4 ON
Wait 50
Send 201h  2  0Fh 00h // RPDO1 Control Word bit 4 OFF
Wait 10

Inposition1:
Send 601h  8 40h 41h 60h 00h 00h 00h 00h 00h // status word
Wait 10
Waitdata 12 581h 8 4Bh 41h 60h 00h 27h 04h 00h 00h //wait for status word bit 10 (Target Reached)
//other bits could be set in Status Word as follows.  These are also ok.
	if false
		Waitdata 12 581h 8 4Bh 41h 60h 00h 27h 05h 00h 00h
			if false
				Waitdata 12 581h 8 4Bh 41h 60h 00h 27h 14h 00h 00h
					if false
						Waitdata 12 581h 8 4Bh 41h 60h 00h 27h 15h 00h 00h
							if false
								goto Inposition1

//Enter Target Position Setpoint
Send 301h  8  00h 00h 00h 00h E8h 03h 00h 00h // RPDO2 target position - sets a new target position
Wait 50
Send 201h  2  1Fh 00h // RPDO1 Control Word bit 4 ON
Wait 50
Send 201h  2  0Fh 00h // RPDO1 Control Word bit 4 OFF
Wait 10

Inposition2:
Send 601h  8 40h 41h 60h 00h 00h 00h 00h 00h // status word
Wait 10
Waitdata 12 581h 8 4Bh 41h 60h 00h 27h 04h 00h 00h //wait for status word bit 10 (Target Reached)
//other bits could be set in Status Word as follows.  These are also ok.
	if false
		Waitdata 12 581h 8 4Bh 41h 60h 00h 27h 05h 00h 00h
			if false
				Waitdata 12 581h 8 4Bh 41h 60h 00h 27h 14h 00h 00h
					if false
						Waitdata 12 581h 8 4Bh 41h 60h 00h 27h 15h 00h 00h
							if false
								goto Inposition2

wait 10
GoTo JumpToHere


PDOselect:

Send 601h  8  2Fh 01h 26h 00h 26h 00h 00h 00h // Select PDO 38 as RPDO2
Wait 20
Send 601h 8 40h 01h 26h 00h 00h 00h 00h 00h
Wait 20
Return


RPDO2delete:
	
Send 601h  8  23h 01h 16h 00h 00h 00h 00h 00h // delete RPDO2 mapping
Wait 20
Send 601h 8 40h 01h 16h 00h 00h 00h 00h 00h // RPDO2
Wait 20
Return


RPDO2map:
//Map Target Position (Obj.607A) to RPDO2 
Send 601h  8  23h 01h 16h 01h 20h 00h 7Ah 60h // RPDO2 entry 1: target position
Wait 20
Send 601h 8 40h 01h 16h 01h 00h 00h 00h 00h // RPDO2 entry 1
Wait 20
Return
